namespace LM{

class log{
	
	// log lines
	array<string> logLinesDefault = {"Log is empty"};
	array<string> logLines = logLinesDefault;
	string text_data = "";

	// flags and vars
	double renderAreaH = 100, renderAreaW = 200, lineHeight = 14, scrollHeight;
	uint maxcharsinline = 50;
	bool auto_maxcharsinline = false;

	uint log_lines_max_visible;
	uint lines_qty;
	uint font_size = 11;
	uint hPadding = 8;
	string split_by_chars = "";

	Kt::Param@ ktp_LINES_QTY, ktp_INVISIBLE_LINES_QTY;

	// colors
	double bgR, bgG, bgB, bgO, txR, txG, txB, txO;


	// constructor
	log(Kt::Param@ lines_qty, Kt::Param@ inv_lines_qty, string init_text, string _maxcharsinline, uint _font_size, string _split_by_chars, string text_color, string background_color, double background_opacity, double _h_padding = 8){
		// link local params to real params
		@ktp_LINES_QTY = lines_qty;
		@ktp_INVISIBLE_LINES_QTY = inv_lines_qty;
		if (_maxcharsinline != "auto") {
			maxcharsinline = parseInt(_maxcharsinline) ; 
			if (maxcharsinline<1) {
				auto_maxcharsinline = true;
				maxcharsinline = 30;
			}
		} else {
			// count max chars in line later, when calcLogLines
			auto_maxcharsinline = true;
		}
		font_size = _font_size;
		hPadding = uint(_h_padding);
		split_by_chars = _split_by_chars;

		if (init_text.length > 0) {
			parseString(init_text);
		}

		bgR = double(parseInt(background_color.substr(1,2),16))/255.0;
		bgG = double(parseInt(background_color.substr(3,2),16))/255.0;
		bgB = double(parseInt(background_color.substr(5,2),16))/255.0;
		bgO = background_opacity; string bgOT = background_color.substr(7,2);
		if (bgOT.length > 0) bgO = double(parseInt(bgOT,16))/255.0;

		txR = double(parseInt(text_color.substr(1,2),16))/255.0;
		txG = double(parseInt(text_color.substr(3,2),16))/255.0;
		txB = double(parseInt(text_color.substr(5,2),16))/255.0;
		txO = 1; string txOT = text_color.substr(7,2);
		if (txOT.length > 0) txO = double(parseInt(txOT,16))/255.0;

		// datetime d;
		// string time = formatFloat(d.get_hour(),"0", 2, 0) + "" + formatFloat(d.get_minute(),"0", 2, 0) + "" + formatFloat(d.get_second(),"0", 2, 0);
	}

	// destructor
	~log(){

	}

	void parseString(string _text_data) {
		if (_text_data.findFirst("\\"+"n") > -1) {
			replaceString(_text_data, "\\"+"n", "\n");
		}
		text_data = _text_data;
		splitLines();

		calcLogLines();
	}

	void splitLines(){
		array<string> logLines_pre = text_data.split("\n");
		logLines.resize(0);
		for(uint i=0;i<logLines_pre.length;i++){
			string thisline = logLines_pre[i];
			if (thisline.length > maxcharsinline) {
				bool has_more_text = true;
				int posstart = 0;
				int posend = maxcharsinline;
				int ln = 0;
				int pos = 0;
				string shortline;
				do{
					shortline = thisline.substr(posstart, maxcharsinline);
					if (split_by_chars.length > 0) {
						pos = shortline.findLastOf(split_by_chars);
					} else {
						pos = 0;
					}
					if (pos > 0) {
						pos++;
						shortline = thisline.substr(posstart, pos);
					} else {
						pos = maxcharsinline;
					}

					logLines.insertLast(shortline);
					posstart += pos;
					ln++;
				} while (posstart < int(thisline.length));

				// split into several lines (not aware of spaces)
				// int fitsintolines = int(ceil(thisline.length/maxcharsinline));
				// logLines[i] = thisline.substr(0, maxcharsinline);
				// for (uint n = 1; n <= uint(fitsintolines); n++) {
				// 	logLines.insertAt(i+n, thisline.substr(n*maxcharsinline, maxcharsinline));
				// }
			} else {
				logLines.insertLast(thisline);
			}
		}
	}

	void calcMaxCharsInLine() {
		// calc maxcharsinline
		if (auto_maxcharsinline) {
			uint maxcharsinline_old = maxcharsinline;
			double w100 = text_measure_mono_font_size_11.width;
			double areaw = (renderAreaW-hPadding);
			if (font_size < 11) {
				w100 *= double(font_size)/11.0;
			}
			if (font_size >= 12) {
				w100 = text_measure_mono_font_size_12.width;
				areaw = (renderAreaW-hPadding*2);
			}
			if (font_size >= 14) {
				w100 = text_measure_mono_font_size_14.width;
			}
			if (font_size > 14) {
				w100 *= double(font_size)/14.0;
			}
			double w1 = w100/100.0;
			
			maxcharsinline = uint(floor(areaw / w1));

			// if (maxcharsinline != maxcharsinline_old) {
			// 	reParseString();
			// }
			//status(""+areaw + "/" + w1+"="+maxcharsinline);

		}
	}

	void calcLogLines(){
		// calc log lines
		lines_qty = logLines.length;
		ktp_LINES_QTY = lines_qty;

		// calc invisible log lines
		log_lines_max_visible = uint(rint(floor(renderAreaH/lineHeight)));
		int log_lines_invisible = 0;
		if (lines_qty > log_lines_max_visible) log_lines_invisible = lines_qty - log_lines_max_visible;
		ktp_INVISIBLE_LINES_QTY = log_lines_invisible;

		// calc scrollheight
		scrollHeight = lineHeight*lines_qty - renderAreaH + lineHeight/2;
	}


	// for canvas drawing
	bool is_first_render = true;
	double old_width = 0;
	void render(double h, double w, double yscroll){
		renderAreaH = h;
		renderAreaW = w;


		if (is_first_render or (old_width != w)) {
			calcMaxCharsInLine();
			splitLines();
			calcLogLines();
			old_width = w;
			is_first_render = false;
		}
		if (log_lines_max_visible >= lines_qty) yscroll=0;
 		
		
		auto ctx=Kt::Graphics::GetCurrentContext();
		
		// draw white background
		ctx.path.Clear();
		ctx.source.SetRGBA (bgR,bgG,bgB,bgO);

		ctx.path.Rectangle(0,0,w,h);
		ctx.FillPath();

		// set font params
		ctx.font.SetFontSize(font_size);
    	ctx.font.SelectFontFace("$DEFAULT_MONOSPACE_FONT$", Kt::Graphics::kFontSlantNormal, Kt::Graphics::kFontWeightNormal);
    	ctx.source.SetRGBA (txR,txG,txB,txO);

  //   	ctx.path.MoveTo(0,10);
		// ctx.WriteText("" + renderAreaW + "x" + renderAreaH);

	    // calculate coords
	    double x = hPadding, y = lineHeight;

	 //    ctx.path.MoveTo(100,10);
		// ctx.WriteText("max: " + log_lines_max_visible +" actual:" +lines_qty);

	   	// "scroll" to where we are
	    ctx.transform.Translate(0,yscroll*-scrollHeight);

		for(uint i=0;i<logLines.length;i++){
			ctx.path.MoveTo(x,y);
			ctx.WriteText(logLines[i]);
			y+=lineHeight;
		}

		// draw line
		ctx.transform.Translate(0,yscroll*scrollHeight);
		
		ctx.source.SetRGBA (bgR,bgG,bgB,bgO*bgO*bgO*0.8);
		ctx.path.Clear();
		ctx.path.Rectangle(0,0,w,3);
		ctx.FillPath();
		ctx.path.Clear();
		ctx.path.Rectangle(0,h-3,w,3);
		ctx.FillPath();
	}

}

}